#include <reg52.h> 
#include <intrins.h>

 
#define DATAIN	0x01 // 0000 0001
 
sbit CLK_Pin     = P2^0;
sbit CS_Pin      = P2^1;
sbit SARS_Pin    = P2^2;
sbit DI_Pin      = P2^3;
sbit DO_Pin      = P2^4;

code const Index[18] = {0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 
					   0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01, 0x00};
unsigned char DATA[2]={0};


void ADC_Data_In(void)
{	
	unsigned char n=0;

	CLK_Pin = 0;
	CS_Pin = 1;
	
	CLK_Pin = 1;
	CLK_Pin = 0;

	SARS_Pin = 0;
	
	do
	{
		CLK_Pin = 0;

		if(DATAIN & Index[n])
		{
		 	DI_Pin = 1;
		}
		else
		{
			DI_Pin = 0;
	    }

		CS_Pin = 0;
		CLK_Pin = 1;

	}while(Index[++n]!=0x10);
}

void ADC_Data_Out(void)
{
	unsigned char n=0, Byte=0;

	CLK_Pin = 0;
	SARS_Pin = 1;
	
	do
	{
		CLK_Pin = 0;

		if(DO_Pin & 1)
		{
			DATA[Byte] = DATA[Byte] | Index[n];	
		}		
		else
		{
			DATA[Byte] = DATA[Byte] & ~Index[n];
		}
		if	(n==0x07)	
		{
			SARS_Pin = 0;
			Byte = 1;
		}  
		CLK_Pin = 1; 			

	}while(Index[++n]!=0x00); 
	
	CLK_Pin = 0;
	CLK_Pin = 1;
	
	CLK_Pin = 0;
	CLK_Pin = 1;
	CLK_Pin = 0;
 	CLK_Pin = 1;
	CLK_Pin = 0;
		
	CS_Pin = 1;	  	
}

void main(void)
{

 	while(1)
	{
	 	ADC_Data_In();
		ADC_Data_Out();

		P0 = DATA[0];
		P3 = DATA[1];

		DATA[0] = 0;
		DATA[1] = 0;


	}
}
